#ifndef __chiliproject_h__
#define __chiliproject_h__
#include <config.h>
#include <string>
using namespace std;
class ChiliSession;
class ChiliAudioChannel;
class ChiliProject {
friend class ChiliSession;
private:
	ChiliSession * session;
	unsigned int slotnum;
	unsigned int lasterror;

	unsigned int samplerate;
	unsigned int numberofchannels;

	/* GUI stuff follows */
	bool isVisual;
	ChiliAudioChannel * channellist[MAXCHANNELS];
	unsigned int GetFreeChannel();	
	string workingfile;
	string filekey;
public:
	ChiliProject(ChiliSession * p_session,const unsigned int p_slotnum,const string strProjname);
	~ChiliProject();

	bool isContainer(string strFileName);
	void LoadContainerFiles(string strFileName);

	unsigned int AddChannel();
	/* Will add an empty audio channel to the project. 
	   Returns with zero based channel number if successful,
           or MAXCHANNELS otherwise. */
	unsigned int AddChannel(string strFileName);
	/* Will add an empty audio channel to the project, 
	   then link the file with the given filename to it.
	   This file should contain decoded audio info.
	   Returns with zero based channel number if successful,
           or MAXCHANNELS otherwise. */

	unsigned int DelChannel();
	/* Will add an empty audio channel to the project. 
	   Returns with zero based channel number if successful,
           or MAXCHANNELS otherwise. */

	unsigned int SetSampleRate(const unsigned int rate);
	/* Will set the default (save/mixdown) project samplerate. 
	   Return value is the new sample rate, which can be used
           to see if setting the rate was successful. Not each
	   possible sample rate may be supported by every platform. */

	unsigned int GetNumberOfChannels();

	float GetMinPeak(int channel,int pos,int maxpos,float zoom);
	float GetMaxPeak(int channel,int pos,int maxpos,float zoom);
};
#endif
