#include <config.h>
#ifndef __chilisession_h__
#define __chilisession_h__
class ChiliUISession;
#include <FL/Fl_Window.H>
#include <FL/filename.H>
#include <FL/Fl_Preferences.H>
#include <string>

using namespace std;
class ChiliProject;
class ChiliSession {
friend class ChiliProject;
private:
	unsigned int lasterror;
	unsigned int GetFreeSlot();
	ChiliUISession * uisession;
	ChiliProject * projectlist[MAXPROJECTS];
        string systemhomedir;
	string userhomedir;
	string tempdir;
	Fl_Preferences * sysprefs;
	Fl_Preferences * userprefs;
	void ChiliSessionInit();
public:
	void SetUISession(ChiliUISession * p_uisession);
	ChiliUISession * GetUISession();

	ChiliSession();
	~ChiliSession();
	unsigned int GetLastError();
	string GetTempDir();
	Fl_Preferences * GetUserPrefs();
	Fl_Preferences * GetSysPrefs();
	unsigned int CreateProject(string filename);
	ChiliProject * GetProjectBySlot(const unsigned int projid);

	unsigned int CloseProject(const unsigned int proj_id,bool confirm);
	/* Closes the project that is in slot proj_id, optionally
           after confirmation. If the slot is empty, this function
 	   has no effect and returns with success. */


};
#endif
